Where do I find a standard Trie based map implementation in Java?

JavaAlgorithmOptimizationTrie

Java Problem Overview


I have a Java program that stores a lot of mappings from Strings to various objects.

Right now, my options are either to rely on hashing (via HashMap) or on binary searches (via TreeMap). I am wondering if there is an efficient and standard trie-based map implementation in a popular and quality collections library?

I've written my own in the past, but I'd rather go with something standard, if available.

Quick clarification: While my question is general, in the current project I am dealing with a lot of data that is indexed by fully-qualified class name or method signature. Thus, there are many shared prefixes.

Java Solutions


Solution 1 - Java

You might want to look at the Trie implementation that Limewire is contributing to the Google Guava.

Solution 2 - Java

There is no trie data structure in the core Java libraries.

This may be because tries are usually designed to store character strings, while Java data structures are more general, usually holding any Object (defining equality and a hash operation), though they are sometimes limited to Comparable objects (defining an order). There's no common abstraction for "a sequence of symbols," although CharSequence is suitable for character strings, and I suppose you could do something with Iterable for other types of symbols.

Here's another point to consider: when trying to implement a conventional trie in Java, you are quickly confronted with the fact that Java supports Unicode. To have any sort of space efficiency, you have to restrict the strings in your trie to some subset of symbols, or abandon the conventional approach of storing child nodes in an array indexed by symbol. This might be another reason why tries are not considered general-purpose enough for inclusion in the core library, and something to watch out for if you implement your own or use a third-party library.

Solution 3 - Java

Apache Commons Collections v4.0 now supports trie structures.

See the org.apache.commons.collections4.trie package info for more information. In particular, check the PatriciaTrie class:

> Implementation of a PATRICIA Trie (Practical Algorithm to Retrieve Information Coded in Alphanumeric). > > A PATRICIA Trie is a compressed Trie. Instead of storing all data at the edges of the Trie (and having empty internal nodes), PATRICIA stores data in every node. This allows for very efficient traversal, insert, delete, predecessor, successor, prefix, range, and select(Object) operations. All operations are performed at worst in O(K) time, where K is the number of bits in the largest item in the tree. In practice, operations actually take O(A(K)) time, where A(K) is the average number of bits of all items in the tree.

Solution 4 - Java

Also check out concurrent-trees. They support both Radix and Suffix trees and are designed for high concurrency environments.

Solution 5 - Java

I wrote and published a simple and fast implementation here.

Solution 6 - Java

What you need is org.apache.commons.collections.FastTreeMap , I think.

Solution 7 - Java

Below is a basic HashMap implementation of a Trie. Some people might find this useful...

class Trie {
	
	HashMap<Character, HashMap> root;
	
	public Trie() {
		root = new HashMap<Character, HashMap>();
	}
	
	public void addWord(String word) {
		HashMap<Character, HashMap> node = root;
		for (int i = 0; i < word.length(); i++) {
			Character currentLetter = word.charAt(i);
			if (node.containsKey(currentLetter) == false) {
				node.put(currentLetter, new HashMap<Character, HashMap>());
			}
			node = node.get(currentLetter);
		}
	}
	
	public boolean containsPrefix(String word) {
		HashMap<Character, HashMap> node = root;
		for (int i = 0; i < word.length(); i++) {
			Character currentLetter = word.charAt(i);
			if (node.containsKey(currentLetter)) {
				node = node.get(currentLetter);
			} else {
				return false;
			}
		}
		return true;
	}
}

Solution 8 - Java

Solution 9 - Java

You can try the Completely Java library, it features a PatriciaTrie implementation. The API is small and easy to get started, and it's available in the Maven central repository.

Solution 10 - Java

You might look at this TopCoder one as well (registration required...).

Solution 11 - Java

If you required sorted map, then tries are worthwhile. If you don't then hashmap is better. Hashmap with string keys can be improved over the standard Java implementation: Array hash map

Solution 12 - Java

If you're not worried about pulling in the Scala library, you can use this space efficient implementation I wrote of a burst trie.

https://github.com/nbauernfeind/scala-burst-trie

Solution 13 - Java

here is my implementation, enjoy it via: GitHub - MyTrie.java

/* usage:
    MyTrie trie = new MyTrie();
    trie.insert("abcde");
    trie.insert("abc");
    trie.insert("sadas");
    trie.insert("abc");
    trie.insert("wqwqd");
    System.out.println(trie.contains("abc"));
    System.out.println(trie.contains("abcd"));
    System.out.println(trie.contains("abcdefg"));
    System.out.println(trie.contains("ab"));
    System.out.println(trie.getWordCount("abc"));
    System.out.println(trie.getAllDistinctWords());
*/

import java.util.*;

public class MyTrie {
  private class Node {
    public int[] next = new int[26];
    public int wordCount;
    public Node() {
      for(int i=0;i<26;i++) {
        next[i] = NULL;
      }
      wordCount = 0;
    }
  }
  
  private int curr;
  private Node[] nodes;
  private List<String> allDistinctWords;
  public final static int NULL = -1;
  
  public MyTrie() {
    nodes = new Node[100000];
    nodes[0] = new Node();
    curr = 1;
  }
  
  private int getIndex(char c) {
    return (int)(c - 'a');
  }
  
  private void depthSearchWord(int x, String currWord) {
    for(int i=0;i<26;i++) {
      int p = nodes[x].next[i];
      if(p != NULL) {
        String word = currWord + (char)(i + 'a');
        if(nodes[p].wordCount > 0) {
          allDistinctWords.add(word);
        }
        depthSearchWord(p, word);
      }
    }
  }
  
  public List<String> getAllDistinctWords() {
    allDistinctWords = new ArrayList<String>();
    depthSearchWord(0, "");
    return allDistinctWords;
  }
  
  public int getWordCount(String str) {
    int len = str.length();
    int p = 0;
    for(int i=0;i<len;i++) {
      int j = getIndex(str.charAt(i));
      if(nodes[p].next[j] == NULL) {
        return 0;
      }
      p = nodes[p].next[j];
    }
    return nodes[p].wordCount;
  }
  
  public boolean contains(String str) {
    int len = str.length();
    int p = 0;
    for(int i=0;i<len;i++) {
      int j = getIndex(str.charAt(i));
      if(nodes[p].next[j] == NULL) {
        return false;
      }
      p = nodes[p].next[j];
    }
    return nodes[p].wordCount > 0;
  }
  
  public void insert(String str) {
    int len = str.length();
    int p = 0;
    for(int i=0;i<len;i++) {
      int j = getIndex(str.charAt(i));
      if(nodes[p].next[j] == NULL) {
        nodes[curr] = new Node();
        nodes[p].next[j] = curr;
        curr++;
      }
      p = nodes[p].next[j];
    }
    nodes[p].wordCount++;
  }
}

Solution 14 - Java

I have just tried my own Concurrent TRIE implementation but not based on characters, it is based on HashCode. Still We can use this having Map of Map for each CHAR hascode.
You can test this using the code @ https://github.com/skanagavelu/TrieHashMap/blob/master/src/TrieMapPerformanceTest.java https://github.com/skanagavelu/TrieHashMap/blob/master/src/TrieMapValidationTest.java

import java.util.concurrent.atomic.AtomicReferenceArray;

public class TrieMap {
	public static int SIZEOFEDGE = 4; 
	public static int OSIZE = 5000;
}

abstract class Node {
	public Node getLink(String key, int hash, int level){
		throw new UnsupportedOperationException();
	}
	public Node createLink(int hash, int level, String key, String val) {
		throw new UnsupportedOperationException();
	}
	public Node removeLink(String key, int hash, int level){
		throw new UnsupportedOperationException();
	}
}

class Vertex extends Node {
	String key;
	volatile String val;
	volatile Vertex next;
	
	public Vertex(String key, String val) {
		this.key = key;
		this.val = val;
	}
	
	@Override
	public boolean equals(Object obj) {
		Vertex v = (Vertex) obj;
		return this.key.equals(v.key);
	}
	
    @Override
	public int hashCode() {
		return key.hashCode();
	}
	
	@Override
	public String toString() {
		return key +"@"+key.hashCode();
	}
}


class Edge extends Node {
	volatile AtomicReferenceArray<Node> array; //This is needed to ensure array elements are volatile
	
	public Edge(int size) {
		array = new AtomicReferenceArray<Node>(8);
	}
	
    
	@Override
	public Node getLink(String key, int hash, int level){
		int index = Base10ToBaseX.getBaseXValueOnAtLevel(Base10ToBaseX.Base.BASE8, hash, level);
		Node returnVal = array.get(index);
		for(;;) {
			if(returnVal == null) {
				return null;
			}
			else if((returnVal instanceof Vertex)) {
				Vertex node = (Vertex) returnVal;
				for(;node != null; node = node.next) {
					if(node.key.equals(key)) {	
						return node; 
					}
				} 
				return null;
			} else { //instanceof Edge
				level = level + 1;
				index = Base10ToBaseX.getBaseXValueOnAtLevel(Base10ToBaseX.Base.BASE8, hash, level);
				Edge e = (Edge) returnVal;
				returnVal = e.array.get(index);
			}
		}
	}
	
	@Override
	public Node createLink(int hash, int level, String key, String val) { //Remove size
		for(;;) { //Repeat the work on the current node, since some other thread modified this node
			int index =  Base10ToBaseX.getBaseXValueOnAtLevel(Base10ToBaseX.Base.BASE8, hash, level);
			Node nodeAtIndex = array.get(index);
		    if ( nodeAtIndex == null) {  
		    	Vertex newV = new Vertex(key, val);
		    	boolean result = array.compareAndSet(index, null, newV);
		    	if(result == Boolean.TRUE) {
		    	   	return newV;
		    	}
		    	//continue; since new node is inserted by other thread, hence repeat it.
			} 
		    else if(nodeAtIndex instanceof Vertex) {
		    	Vertex vrtexAtIndex = (Vertex) nodeAtIndex;
		    	int newIndex = Base10ToBaseX.getBaseXValueOnAtLevel(Base10ToBaseX.Base.BASE8, vrtexAtIndex.hashCode(), level+1);
		    	int newIndex1 = Base10ToBaseX.getBaseXValueOnAtLevel(Base10ToBaseX.Base.BASE8, hash, level+1);
		    	Edge edge = new Edge(Base10ToBaseX.Base.BASE8.getLevelZeroMask()+1);
		    	if(newIndex != newIndex1) {
		    		Vertex newV = new Vertex(key, val);
		    		edge.array.set(newIndex, vrtexAtIndex);
		    		edge.array.set(newIndex1, newV);
		    		boolean result = array.compareAndSet(index, vrtexAtIndex, edge); //REPLACE vertex to edge
		    	    if(result == Boolean.TRUE) {
		    	    	return newV;
		    	    }
 		    	   //continue; since vrtexAtIndex may be removed or changed to Edge already.
		    	} else if(vrtexAtIndex.key.hashCode() == hash) {//vrtex.hash == hash) {       HERE newIndex == newIndex1
		    		synchronized (vrtexAtIndex) {	
		    			boolean result = array.compareAndSet(index, vrtexAtIndex, vrtexAtIndex); //Double check this vertex is not removed.
			    	    if(result == Boolean.TRUE) {
			    	    	Vertex prevV = vrtexAtIndex;
			    	    	for(;vrtexAtIndex != null; vrtexAtIndex = vrtexAtIndex.next) {
			    	    		prevV = vrtexAtIndex; // prevV is used to handle when vrtexAtIndex reached NULL
			    	    		if(vrtexAtIndex.key.equals(key)){
			    	    			vrtexAtIndex.val = val;
			    	    			return vrtexAtIndex;
			    	    		}
			    	    	} 
			    	    	Vertex newV = new Vertex(key, val);
			    	    	prevV.next = newV; // Within SYNCHRONIZATION since prevV.next may be added with some other.
			    		  	return newV;
			    	    }
			    	    //Continue; vrtexAtIndex got changed
		    		}
		    	} else {   //HERE newIndex == newIndex1  BUT vrtex.hash != hash
		    		edge.array.set(newIndex, vrtexAtIndex);
		    		boolean result = array.compareAndSet(index, vrtexAtIndex, edge); //REPLACE vertex to edge
		    	    if(result == Boolean.TRUE) {
		    	    	return edge.createLink(hash, (level + 1), key, val);
		    	    }
		    	}
	    	} 		    	
			else {  //instanceof Edge
				return nodeAtIndex.createLink(hash, (level + 1), key, val);
			}
		}
	}
	

	
	
	@Override
	public Node removeLink(String key, int hash, int level){
		for(;;) {
			int index = Base10ToBaseX.getBaseXValueOnAtLevel(Base10ToBaseX.Base.BASE8, hash, level);
			Node returnVal = array.get(index);
			if(returnVal == null) {
				return null;
			}
			else if((returnVal instanceof Vertex)) {
				synchronized (returnVal) {
					Vertex node = (Vertex) returnVal;
					if(node.next == null) {
						if(node.key.equals(key)) {
							boolean result = array.compareAndSet(index, node, null); 
							if(result == Boolean.TRUE) {
								return node;
							}
							continue; //Vertex may be changed to Edge
						}
						return null;  //Nothing found; This is not the same vertex we are looking for. Here hashcode is same but key is different. 
					} else {
						if(node.key.equals(key)) { //Removing the first node in the link
							boolean result = array.compareAndSet(index, node, node.next);
							if(result == Boolean.TRUE) {
								return node;
							}
							continue; //Vertex(node) may be changed to Edge, so try again.
						}
						Vertex prevV = node; // prevV is used to handle when vrtexAtIndex is found and to be removed from its previous
						node = node.next;
						for(;node != null; prevV = node, node = node.next) {
							if(node.key.equals(key)) {
								prevV.next = node.next; //Removing other than first node in the link
								return node; 
							}
						} 
						return null;  //Nothing found in the linked list.
					}
				}
			} else { //instanceof Edge
				return returnVal.removeLink(key, hash, (level + 1));
			}
		}
	}
	
}



class Base10ToBaseX {
	public static enum Base {
		/**
		 * Integer is represented in 32 bit in 32 bit machine.
		 * There we can split this integer no of bits into multiples of 1,2,4,8,16 bits
		 */
		BASE2(1,1,32), BASE4(3,2,16), BASE8(7,3,11)/* OCTAL*/, /*BASE10(3,2),*/ 
		BASE16(15, 4, 8){		
			public String getFormattedValue(int val){
				switch(val) {
				case 10:
					return "A";
				case 11:
					return "B";
				case 12:
					return "C";
				case 13:
					return "D";
				case 14:
					return "E";
				case 15:
					return "F";
				default:
					return "" + val;
				}
				
			}
		}, /*BASE32(31,5,1),*/ BASE256(255, 8, 4), /*BASE512(511,9),*/ Base65536(65535, 16, 2);
		
		private int LEVEL_0_MASK;
		private int LEVEL_1_ROTATION;
		private int MAX_ROTATION;
		
		Base(int levelZeroMask, int levelOneRotation, int maxPossibleRotation) {
			this.LEVEL_0_MASK = levelZeroMask;
			this.LEVEL_1_ROTATION = levelOneRotation;
			this.MAX_ROTATION = maxPossibleRotation;
		}
		
		int getLevelZeroMask(){
			return LEVEL_0_MASK;
		}
		int getLevelOneRotation(){
			return LEVEL_1_ROTATION;
		}
		int getMaxRotation(){
			return MAX_ROTATION;
		}
		String getFormattedValue(int val){
			return "" + val;
		}
	}
	
	public static int getBaseXValueOnAtLevel(Base base, int on, int level) {
		if(level > base.getMaxRotation() || level < 1) {
			return 0; //INVALID Input
		}
		int rotation = base.getLevelOneRotation();
		int mask = base.getLevelZeroMask();

		if(level > 1) {
			rotation = (level-1) * rotation;
			mask = mask << rotation;
		} else {
			rotation = 0;
		}
		return (on & mask) >>> rotation;
	}
}

Attributions

All content for this solution is sourced from the original question on Stackoverflow.

The content on this page is licensed under the Attribution-ShareAlike 4.0 International (CC BY-SA 4.0) license.

Content TypeOriginal AuthorOriginal Content on Stackoverflow
QuestionUriView Question on Stackoverflow
Solution 1 - JavaDavid SchlosnagleView Answer on Stackoverflow
Solution 2 - JavaericksonView Answer on Stackoverflow
Solution 3 - JavaDuncan JonesView Answer on Stackoverflow
Solution 4 - JavaAlex BeardsleyView Answer on Stackoverflow
Solution 5 - JavaMelinda GreenView Answer on Stackoverflow
Solution 6 - JavaandriiView Answer on Stackoverflow
Solution 7 - JavamartynasView Answer on Stackoverflow
Solution 8 - JavaIlya KharlamovView Answer on Stackoverflow
Solution 9 - JavaFilipe Miguel FonsecaView Answer on Stackoverflow
Solution 10 - JavaTofuBeerView Answer on Stackoverflow
Solution 11 - JavaRokLView Answer on Stackoverflow
Solution 12 - JavaNateView Answer on Stackoverflow
Solution 13 - JavacoderzView Answer on Stackoverflow
Solution 14 - JavaKanagavelu SugumarView Answer on Stackoverflow